unit hiInputBox;

interface

uses Kol, Share,Windows,Debug;  

type

  TOnEventAccept = procedure( Sender: PObj; var Accept: Boolean ) of object;
  THIInputBox = class (TDebug)
   private

   public
    _prop_Caption:string;
    _prop_Text:string;
    _prop_Default:string;
    _prop_CancelMode:byte;
    _prop_Position:byte;
    _prop_Password:string;
	_prop_OkButton:string;
	_prop_CancelButton:string;

    _data_Default:THI_Event;
    _data_Text:THI_Event;
    _data_Caption:THI_Event;
    _data_OkButton:THI_Event;
    _data_CancelButton:THI_Event;
    
    _event_onCancel:THI_Event;
    _event_onInput:THI_Event;
    
    procedure _work_doShow(var _Data:TData; Index:word); 

end;
   
implementation

var Defstr, Capt, Text, OkButton, CancelButton, UserAnswer:string; Pos, PasChr:byte;

const WM_COMMAND=273; WM_INITDIALOG=272; EM_SETPASSWORDCHAR=204; 
      DlgConst:array [0..25] of Int64 = (       // -      
        $00000000FFFF0001,
        $80C808C800000000,
        $0098000000000004,
        $0000000000000041,
        $004D000001900008,
        $0068005300200053,
        $0020006C006C0065,
        $00000067006C0044,
        $0,
        $0006000650020000,
        $00000004000B008C,
        $000000000082FFFF,
        $0,
        $0014000650810080,
        $00000003000D008C,
        $000000000081FFFF,
        $0,
        $002C001050010000,
        $00000001000F0034,
        $041A041E0080FFFF,
        $0,
        $5001000000000000,
        $000F0034002C0054,
        $0080FFFF00000002,
        $0435043C0442041E,
        $000000000430043D);
       

procedure ArrangeControls(hDlg:HWND);  //          
var Handle:HWND; DlgRect, Rect:TRect; I, Offset:integer; P:TPoint;
begin
  Offset:=0;
  GetClientRect(GetDlgItem(hDlg,4),Rect);      
  //    ( Char(13))
  for I:=0 to Length(Text)-1 do         
  begin
    if Text[I]=Char(13) then Inc(Offset);
  end;
  Offset:=Offset*Rect.Bottom;
  //   
  SetWindowPos(GetDlgItem(hDlg,4),0,0,0, Rect.Right, Rect.Bottom+Offset, SWP_NOOWNERZORDER or SWP_NOMOVE or SWP_NOZORDER);      
  //   
  GetWindowRect(hDlg,DlgRect);
  for I:=1 to 3 do
  begin
    Handle:=GetDlgItem(hDlg,I);
    GetWindowRect(Handle,Rect);
    P.x:=Rect.Left;
    P.y:=Rect.Top;
    ScreenToClient(hDlg, P);
    SetWindowPos(Handle,0, P.x, P.y + Offset, 0, 0, SWP_NOOWNERZORDER or SWP_NOSIZE or SWP_NOZORDER);
  end;
  //         
  SetWindowPos(hDlg,0,0,0, DlgRect.Right-DlgRect.Left, DlgRect.Bottom+Offset-DlgRect.Top, SWP_NOOWNERZORDER or SWP_NOMOVE or SWP_NOZORDER);
end;


function  DialogProc(hDlg:HWND ; uMsg:UINT ;  wParam:WPARAM;  lParam:LPARAM):bool;stdcall; //   
var wRect, DlgRect:TRect; halfWidth, halfHeight:integer; Parent:HWND;
begin
  result:=true;
  case uMsg of
    WM_COMMAND:
    begin
      case LOWORD(wParam) of
        IDOK:
        begin
          SetLength(UserAnswer, 256);
          SetLength(UserAnswer, GetDlgItemText(hDlg,3,PChar(UserAnswer),256));
          EndDialog(hDlg, IDOK);
        end;
        IDCANCEL:
        begin
          EndDialog(hDlg, IDCANCEL);
        end;
      end;
    end;
      
    WM_INITDIALOG:
    begin
	  SetDlgItemText(hDlg, 1, PChar(OkButton)); //  ""
	  SetDlgItemText(hDlg, 2, PChar(CancelButton)); //  ""
      SetDlgItemText(hDlg, 4, PChar(Text)); //  
      SetDlgItemText(hDlg, 3, PChar(Defstr));  //  -
      SetWindowText(hDlg, PChar(Capt));  // 
      SendMessage (GetDlgItem(hDlg, 3), EM_SETPASSWORDCHAR, PasChr, 0); //  
      
      if Pos = 0 then             //     Position
      begin
        Parent:=GetParent(hDlg);
        if Parent=0 then Parent:=GetDesktopWindow;
        GetWindowRect(hDlg, DlgRect);
        GetWindowRect(Parent, wRect);
        halfWidth:=(wRect.Right-wRect.Left - DlgRect.Right+DlgRect.Left) div 2;
        halfHeight:=(wRect.Bottom-wRect.Top - DlgRect.Bottom+DlgRect.Top) div 2;
        SetWindowPos(hDlg, 0, wRect.Left + halfWidth, wRect.Top + halfHeight, 0, 0, SWP_NOSIZE or SWP_NOZORDER);
      end; 
      ArrangeControls(hDlg);
    end;
  else
    result:= false;
  end;
end;

procedure THIInputBox._work_doShow;
begin
  Defstr:=ReadString(_Data, _data_Default, _prop_Default);
  Capt:=ReadString(_Data,_data_Caption,_prop_Caption );
  Text:= ReadString(_Data,_data_Text,_prop_Text);
  OkButton:= ReadString(_Data,_data_OkButton,_prop_OkButton);
  CancelButton:= ReadString(_Data,_data_CancelButton,_prop_CancelButton);
  Pos:=_prop_Position;
  if _prop_Password<>'' then PasChr:=Byte(_prop_Password[1]) else PasChr:=0; //  

  if  DialogBoxIndirect(hinstance,PDlgTemplate(@DlgConst)^, ReadHandle, @DialogProc)=IDOK then
  begin
    _hi_CreateEvent(_Data,@_event_onInput, UserAnswer); //   ,    ,   ( . UserAnswer) 
  end
  else
  begin
    if _prop_CancelMode = 0 then  Defstr:='';
    _hi_CreateEvent(_Data,@_event_onCancel, Defstr);
  end; 

  SetLength(Defstr,0); //   
  SetLength(Capt,0);
  SetLength(Text,0);
  SetLength(UserAnswer,0);
  SetLength(OkButton,0);
  SetLength(CancelButton,0);
end;

end.